#!/usr/bin/python
'''
Created on Feb 27, 2013

@author: rchen

Replace everything between a and b with c. Spans lines.
I need this because the xml files John gave me were so many and large that
search-core ran out of heap space.
'''
import string, sys, re, getopt
import uuid			# to create a unique filename
import os			# rename file

patternA = "<data_set_desc>"
patternB = "</data_set_desc>"
patternC = ""
outFile = ""
overwrite = False

def usage():
	print "usage: ", sys.argv[0], "[-a:b:c:hOo:] <fileOrDirectory>"
	print "  -a beginning pattern. Default:" + patternA
	print "  -b ending pattern. Default:" + patternB
	print "  -c string to put between -a and -b. Default is blank"
	print "  -h this help"
	print "  -O overwrite input file. Overrides -o"
	print "  -o output file name. Default is stdout"
	print "  -r recurse into directory"
	print "Replace aanythingb to acb. Patterns a and b go into re.match()"
	sys.exit()

try:
	opts, args = getopt.getopt(sys.argv[1:], "a:b:c:hOo:r", ["start", "end", "replacement", "help", "overwriteInput", "outFile", "recurse"])
except getopt.GetoptError, err:
	print str(err)	  #will print something like "option -a not recognized"
	usage()
for o, a in opts:
	if o in ("-a", "--start"):	patternA = a
	elif o in ("-b", "--end"):	patternB = a
	elif o in ("-c", "--replacement"): patternC = a
	elif o in ("-h", "--help"):	usage()
	elif o in ("-O", "--overwrite"):
		outFile = "tmp" + str(uuid.uuid4())
		overwrite = True
	elif o in ("-o", "--outFile"):
		if overwrite == False: outFile = a
	elif o in ("-r", "--recurse"):	print "not yet"
	else: assert False, "unhandled option"
if len(args) != 1:
	usage()

if __name__ == "__main__":
	if outFile != "":
		saveStdout = sys.stdout
		sys.stdout = open(outFile, "w")
	fIn = open(args[0])
	entireFile = fIn.read()
	# it would be better to name the groups since pattern? may have ()
	pattern = "(.*)" + patternA + "(.*?)" + patternB + "(.*)"
	m = re.match(pattern, entireFile, re.MULTILINE|re.DOTALL)
	if m:
		print m.group(1) + patternA + patternC + patternB + m.group(3)
	else:
		print entireFile
	if outFile != "":
		#close(sys.stdout)	doesn't work
		sys.stdout = saveStdout
		if overwrite: os.rename(outFile, args[0])
